#include "fivewin.ch"
#include "xbrowse.ch"
#include "TTitle.ch"

STATIC c_path, c_path1, c_path2, oFont, oFont1, oFont2, oFont3
STATIC nDStyle := 2, nDColorF := 16765559, nDColorB := 255
STATIC nDTxtColor := 255, nDGradpos := 0, LDDirect := .T.
STATIC cDBrush := "Marble.bmp" 

STATIC n1_GradC1, n1_GradC2, c1_GradArr, l1_GradDir, l1_DiagDir, n1_Gradpos, n1_DiagPos, n1_CircleT, n1_CircleL, n1_Grad 
STATIC n2_GradC1, n2_GradC2, c2_GradArr, l2_GradDir, l2_DiagDir, n2_Gradpos, n2_DiagPos, n2_CircleT, n2_CircleL, n2_Grad
STATIC n3_GradC1, n3_GradC2, c3_GradArr, l3_GradDir, l3_DiagDir, n3_Gradpos, n3_DiagPos, n3_CircleT, n3_CircleL, n3_Grad
STATIC n4_GradC1, n4_GradC2, c4_GradArr, l4_GradDir, l4_DiagDir, n4_Gradpos, n4_DiagPos, n4_CircleT, n4_CircleL, n4_Grad
STATIC n5_GradC1, n5_GradC2, c5_GradArr, l5_GradDir, l5_DiagDir, n5_Gradpos, n5_DiagPos, n5_CircleT, n5_CircleL, n5_Grad

FUNCTION MAIN()
LOCAL oDlg1, oFld1, oFBtn1, oFBtn2, oFBtn3, oFBtn4, aBitmaps, oGrd[5], oRGBBtn[5]

SETBALLOON( .T. ) // Balloon shape required for tooltips
REQUEST DBFCDX
RDDSETDEFAULT ( "DBFCDX" )

c_path := cFilePath(GetModuleFileName( GetInstance() ) )
c_path1 := c_Path + "SYSTEM\"

DEFINE FONT oFont NAME "ARIAL" SIZE 0,-10
DEFINE FONT oFont1 NAME "ARIAL" SIZE 0,-12 
DEFINE FONT oFont2 NAME "ARIAL" SIZE 0,-14 
DEFINE FONT oFont3 NAME "ARIAL" SIZE 0,-16 BOLD 

aBitmaps := { c_path1 + "Paint.Bmp",;
                          c_path1 + "Paint.bmp",;
                          c_path1 + "Paint.bmp",;
                          c_path1 + "Paint.bmp",;
                          c_path1 + "Paint.bmp",;
                          c_path1 + "Exit.bmp" }

DEFINE DIALOG oDlg1 TITLE "Folder RGB-colors   => " SIZE 800, 590 PIXEL 

GO_START()
LOAD_DBF(oDlg1, .F.)

@ 10, 10 FOLDEREX SIZE 380, 240 oFld1 PIXEL ROUND 5 UPDATE ;
PROMPT  "Gradient &1", "Gradient &2", "Gradient &3", "Gradient &4", "Gradient &5" OF oDlg1 ;
BITMAPS aBitmaps;
ON PAINT TAB PaintTab( Self, nOption );
ON CHANGE ( nSavePage := oFld1:nOption, ::Refresh() ) ;                         
ON PAINT TEXT( If( nOption == ::nOption .and. nOption == 2, 8388608, 0 ) );
TOP OPTION 1 ALIGN 0, 0, 0, 0, 0 UPDATE

oFld1:lTransparent := .T.
oFld1:nFolderHeight := 30
oFld1:nSeparator := 2
oFld1:bClrText := {| o, n | 128 }
oFld1:oFont := oFont1
oFld1:nOption := 1

@ 185, 325  BTNBMP oRGBBtn[1] OF oFld1:aDialogs[ 1 ] ;
SIZE 46, 29 PIXEL 2007 ; 
NOBORDER ;
PROMPT "&Show " + CRLF + "function" ;
FILENAME c_path1 + "Paint.Bmp" ;
ACTION SHOW_RGB(oFld1, 1) ;
LEFT
oRGBBtn[1]:bClrGrad = { | lMouseOver | If( ! lMouseOver,;
		{ { 0.50, 11513775, 16777215 }, ;
		{ 0.50, 16777215, 11513775 } }, ;
		{ { 0.50, 16761992, 16777215 }, ;
		{ 0.50, 16777215, 16761992 } } ) }
oRGBBtn[1]:lTransparent := .t.   
oRGBBtn[1]:cToolTip =  { "Show RGB","RGB", 1, CLR_BLACK, 14089979 }
oRGBBtn[1]:SetColor( 0, )

@ 185, 325  BTNBMP oRGBBtn[2] OF oFld1:aDialogs[ 2 ] ;
SIZE 46, 29 PIXEL 2007 ; 
NOBORDER ;
PROMPT " &Show" + CRLF + "function" ;
FILENAME c_path1 + "Paint.Bmp" ;
ACTION SHOW_RGB(oFld1, 2) ;
LEFT
oRGBBtn[2]:bClrGrad = { | lMouseOver | If( ! lMouseOver,;
		{ { 0.50, 11513775, 16777215 }, ;
		{ 0.50, 16777215, 11513775 } }, ;
		{ { 0.50, 16761992, 16777215 }, ;
		{ 0.50, 16777215, 16761992 } } ) }
oRGBBtn[2]:lTransparent := .t.   
oRGBBtn[2]:cToolTip =  { "Show RGB","RGB", 1, CLR_BLACK, 14089979 }
oRGBBtn[2]:SetColor( 0, )

@ 185, 325  BTNBMP oRGBBtn[3] OF oFld1:aDialogs[ 3 ] ;
SIZE 46, 29 PIXEL 2007 ; 
NOBORDER ;
PROMPT " &Show" + CRLF + "function" ;
FILENAME c_path1 + "Paint.Bmp" ;
ACTION SHOW_RGB(oFld1, 3) ;
LEFT
oRGBBtn[3]:bClrGrad = { | lMouseOver | If( ! lMouseOver,;
		{ { 0.50, 11513775, 16777215 }, ;
		{ 0.50, 16777215, 11513775 } }, ;
		{ { 0.50, 16761992, 16777215 }, ;
		{ 0.50, 16777215, 16761992 } } ) }
oRGBBtn[3]:lTransparent := .t.   
oRGBBtn[3]:cToolTip =  { "Show RGB","RGB", 1, CLR_BLACK, 14089979 }
oRGBBtn[3]:SetColor( 0, )

@ 185, 325  BTNBMP oRGBBtn[4] OF oFld1:aDialogs[ 4 ] ;
SIZE 46, 29 PIXEL 2007 ; 
NOBORDER ;
PROMPT " &Show" + CRLF + "function" ;
FILENAME c_path1 + "Paint.Bmp" ;
ACTION SHOW_RGB(oFld1, 4) ;
LEFT
oRGBBtn[4]:bClrGrad = { | lMouseOver | If( ! lMouseOver,;
		{ { 0.50, 11513775, 16777215 }, ;
		{ 0.50, 16777215, 11513775 } }, ;
		{ { 0.50, 16761992, 16777215 }, ;
		{ 0.50, 16777215, 16761992 } } ) }
oRGBBtn[4]:lTransparent := .t.   
oRGBBtn[4]:cToolTip =  { "Show RGB","RGB", 1, CLR_BLACK, 14089979 }
oRGBBtn[4]:SetColor( 0, )

@ 185, 325  BTNBMP oRGBBtn[5] OF oFld1:aDialogs[ 5 ] ;
SIZE 46, 29 PIXEL 2007 ; 
NOBORDER ;
PROMPT " &Show" + CRLF + "function" ;
FILENAME c_path1 + "Paint.Bmp" ;
ACTION SHOW_RGB(oFld1, 5) ;
LEFT
oRGBBtn[5]:bClrGrad = { | lMouseOver | If( ! lMouseOver,;
		{ { 0.50, 11513775, 16777215 }, ;
		{ 0.50, 16777215, 11513775 } }, ;
		{ { 0.50, 16761992, 16777215 }, ;
		{ 0.50, 16777215, 16761992 } } ) }
oRGBBtn[5]:lTransparent := .t.   
oRGBBtn[5]:cToolTip =  { "Show RGB","RGB", 1, CLR_BLACK, 14089979 }
oRGBBtn[5]:SetColor( 0, )

GET_ARRAY(oFld1)

F_PAGE1( oFld1 )
F_PAGE2( oFld1 )
F_PAGE3( oFld1 )
F_PAGE4( oFld1 )
F_PAGE5( oFld1 )

@  255, 10 TITLE oGrd[1] SIZE 38, 31 PIXEL OF oDlg1 ;
ROUND BORDER SHADOWSIZE 0 UPDATE 
oGrd[1]:bPainted := { |hDC| ( IIF( n1_Grad = 1, DRAW_BMP( oGrd[1], hDC, 1, n1_GradC1, n1_GradC1, l1_GradDir, n1_Gradpos ), NIL ), ;
                                                       IIF( n1_Grad = 2, DRAW_BMP( oGrd[1], hDC, 2, n1_GradC1, n1_GradC2, l1_GradDir, n1_Gradpos ), NIL ), ;
                                                       IIF( n1_Grad = 3, T_CIRCLE( oGrd[1], hDC, n1_GradC1, n1_GradC2, n1_CircleT, n1_CircleL, 1 ), NIL ), ;
                                                       IIF( n1_Grad = 4, T_DIAGONAL( oGrd[1], hDC, n1_GradC1, n1_GradC2, n1_DiagPos, l1_DiagDir, 1 ), NIL ) ) }

@  255, 55 TITLE oGrd[2] SIZE 38, 31 PIXEL OF oDlg1 ;
ROUND BORDER SHADOWSIZE 0 UPDATE 
oGrd[2]:bPainted := { |hDC| ( IIF( n2_Grad = 1, DRAW_BMP( oGrd[2], hDC, 1, n2_GradC1, n2_GradC1, l2_GradDir, n2_Gradpos ), NIL ), ;
                                                       IIF( n2_Grad = 2, DRAW_BMP( oGrd[2], hDC, 2, n2_GradC1, n2_GradC2, l2_GradDir, n2_Gradpos ), NIL ), ;
                                                       IIF( n2_Grad = 3, T_CIRCLE( oGrd[2], hDC, n2_GradC1, n2_GradC2, n2_CircleT, n2_CircleL, 2 ), NIL ), ;
                                                       IIF( n2_Grad = 4, T_DIAGONAL( oGrd[2], hDC, n2_GradC1, n2_GradC2, n2_DiagPos, l2_DiagDir, 2 ), NIL ) ) }

@  255, 100 TITLE oGrd[3] SIZE 38, 31 PIXEL OF oDlg1 ;
ROUND BORDER SHADOWSIZE 0 UPDATE 
oGrd[3]:bPainted := { |hDC| ( IIF( n3_Grad = 1, DRAW_BMP( oGrd[3], hDC, 1, n3_GradC1, n3_GradC1, l3_GradDir, n3_Gradpos ), NIL ), ;
                                                       IIF( n3_Grad = 2, DRAW_BMP( oGrd[3], hDC, 2, n3_GradC1, n3_GradC2, l3_GradDir, n3_Gradpos ), NIL ), ;
                                                       IIF( n3_Grad = 3, T_CIRCLE( oGrd[3], hDC, n3_GradC1, n3_GradC2, n3_CircleT, n3_CircleL, 3 ), NIL ), ;
                                                       IIF( n3_Grad = 4, T_DIAGONAL( oGrd[3], hDC, n3_GradC1, n3_GradC2, n3_DiagPos, l3_DiagDir, 3 ), NIL ) ) }

@  255, 145 TITLE oGrd[4] SIZE 38, 31 PIXEL OF oDlg1 ;
ROUND BORDER SHADOWSIZE 0 UPDATE 
oGrd[4]:bPainted := { |hDC| ( IIF( n4_Grad = 1, DRAW_BMP( oGrd[4], hDC, 1, n4_GradC1, n4_GradC1, l2_GradDir, n4_Gradpos ), NIL ), ;
                                                       IIF( n4_Grad = 2, DRAW_BMP( oGrd[4], hDC, 2, n4_GradC1, n4_GradC2, l2_GradDir, n4_Gradpos ), NIL ), ;
                                                       IIF( n4_Grad = 3, T_CIRCLE( oGrd[4], hDC, n4_GradC1, n4_GradC2, n4_CircleT, n4_CircleL, 4 ), NIL ), ;
                                                       IIF( n4_Grad = 4, T_DIAGONAL( oGrd[4], hDC, n4_GradC1, n4_GradC2, n4_DiagPos, l4_DiagDir, 4 ), NIL ) ) }

@  255, 190 TITLE oGrd[5] SIZE 38, 31 PIXEL OF oDlg1 ;
ROUND BORDER SHADOWSIZE 0 UPDATE 
oGrd[5]:bPainted := { |hDC| ( IIF( n5_Grad = 1, DRAW_BMP( oGrd[5], hDC, 1, n5_GradC1, n5_GradC1, l5_GradDir, n5_Gradpos ), NIL ), ;
                                                       IIF( n5_Grad = 2, DRAW_BMP( oGrd[5], hDC, 2, n5_GradC1, n5_GradC2, l5_GradDir, n5_Gradpos ), NIL ), ;
                                                       IIF( n5_Grad = 3, T_CIRCLE( oGrd[5], hDC, n5_GradC1, n5_GradC2, n5_CircleT, n5_CircleL, 5 ), NIL ), ;
                                                       IIF( n5_Grad = 4, T_DIAGONAL( oGrd[5], hDC, n5_GradC1, n5_GradC2, n5_DiagPos, l5_DiagDir, 5 ), NIL ) ) }

@ 255, 242  BTNBMP oFBtn1 OF oDlg1 ;
SIZE 55, 32 PIXEL 2007 ; 
NOBORDER ;
PROMPT " &Load from" + CRLF + " Project" ;
FILENAME c_path1 + "Minus.Bmp" ;
ACTION ( LOAD_PROJECT( oDlg1, oFld1 ), ;
                  FLD_GRAD( oFld1 ), ;
                  oFld1:SetOption(1), oFld1:aDialogs[1]:Refresh(), oDlg1:Refresh() ) ;
FONT oFont1 ;
LEFT
oFBtn1:bClrGrad = { | lMouseOver | If( ! lMouseOver,;
		{ { 0.50, 11513775, 16777215 }, ;
		{ 0.50, 16777215, 11513775 } }, ;
		{ { 0.50, 16761992, 16777215 }, ;
		{ 0.50, 16777215, 16761992 } } ) }
oFBtn1:lTransparent := .t.   
oFBtn1:cToolTip =  { "SKIP" + CRLF + "previous","SKIP", 1, CLR_BLACK, 14089979 }
oFBtn1:SetColor( 0, )

@ 255, 302  BTNBMP oFBtn2 OF oDlg1 ;
SIZE 20, 32 PIXEL 2007 ; 
NOBORDER ;
PROMPT "" ;
FILENAME c_path1 + "Minus.Bmp" ;
ACTION (  DBSELECTAREA("SET"), DBSKIP(-1), LOAD_DBF(oDlg1, .T.), ;
                    GET_ARRAY(oFld1), FLD_GRAD( oFld1 ), ;
                    oFld1:SetOption(1), oFld1:aDialogs[1]:Refresh(), oDlg1:Refresh() ) ;
LEFT
oFBtn2:bClrGrad = { | lMouseOver | If( ! lMouseOver,;
		{ { 0.50, 11513775, 16777215 }, ;
		{ 0.50, 16777215, 11513775 } }, ;
		{ { 0.50, 16761992, 16777215 }, ;
		{ 0.50, 16777215, 16761992 } } ) }
oFBtn2:lTransparent := .t.   
oFBtn2:cToolTip =  { "SKIP" + CRLF + "previous","SKIP", 1, CLR_BLACK, 14089979 }
oFBtn2:SetColor( 0, )

@ 255, 325  BTNBMP oFBtn3 OF oDlg1 ;
SIZE 20, 32 PIXEL 2007 ; 
NOBORDER ;
PROMPT "" ;
FILENAME c_path1 + "Plus.Bmp" ;
ACTION (  DBSELECTAREA("SET"), DBSKIP(+1), LOAD_DBF(oDlg1, .T.), ;
                   GET_ARRAY(oFld1), FLD_GRAD( oFld1 ), ;
                    oFld1:SetOption(1), oFld1:aDialogs[1]:Refresh(), oDlg1:Refresh() ) ;
LEFT
oFBtn3:bClrGrad = { | lMouseOver | If( ! lMouseOver,;
		{ { 0.50, 11513775, 16777215 }, ;
		{ 0.50, 16777215, 11513775 } }, ;
		{ { 0.50, 16761992, 16777215 }, ;
		{ 0.50, 16777215, 16761992 } } ) }
oFBtn3:lTransparent := .t.   
oFBtn3:cToolTip =  { "SKIP" + CRLF + "next","SKIP", 1, CLR_BLACK, 14089979 }
oFBtn3:SetColor( 0, )

@ 255, 350 BTNBMP oFBtn4 OF oDlg1 ;
SIZE 40, 32 PIXEL 2007 ; 
NOBORDER ;
PROMPT "&Exit Folder" ;
FILENAME c_path1 + "Exit.Bmp" ;
ACTION oDlg1:End() ;
FONT oFont1 ;
TOP
oFBtn4:bClrGrad = { | lMouseOver | If( ! lMouseOver,;
		{ { 0.50, 6711039, 16777215 }, ;
		{ 0.50, 16777215, 6711039 } }, ;
		{ { 0.50, 16761992, 16777215 }, ;
		{ 0.50, 16777215, 16761992 } } ) }
oFBtn4:lTransparent := .t.   
oFBtn4:cToolTip =  { "Exit" + CRLF + "Settings","EXIT", 1, CLR_BLACK, 14089979 }
oFBtn4:SetColor( 0, )

ACTIVATE DIALOG oDlg1 CENTER ;
ON INIT ( WD_BACKGRD( oDlg1, 3, , , , , "Marble.bmp" ), ;
                  FLD_GRAD( oFld1 ) )

oFont:End()
oFont1:End()
oFont2:End()
oFont3:End()

RETURN NIL

// --------------------------

FUNCTION F_PAGE1( oFld1 )
LOCAL oGet, oCheck, oRadio, nRadio := 1, lCheck := .T., oImage, oBtn1
LOCAL oCombo, cCombo := "  Line 1"
LOCAL aBitmaps := { c_path1 + "Alert.Bmp",;
                                        c_path1 + "Alert.bmp",;
                                        c_path1 + "Alert.bmp" }

@ 25, 130 CHECKBOX oCheck VAR lCheck PROMPT "&Checkbox" ;
SIZE 50, 20 OF oFld1:aDialogs[ 1 ] PIXEL UPDATE ;
ON CHANGE MsgBeep()
oCheck:SetColor( 0, )
oCheck:SetFont( oFont3 )
oCheck:lTransparent := .T.

@ 30, 60 RADIO oRadio VAR nRadio OF oFld1:aDialogs[ 1 ] ;
ITEMS "&One", "&Two", "T&hree" _3D SIZE 50, 12 PIXEL UPDATE ;
HELPID 100, 101, 102 ;
ON CHANGE MsgBeep()
AEval( oRadio:aItems, { | oRad | oRad:lTransparent := .T., ;
						     oRad:SetFont ( oFont3 ), ;
                             oRad:nClrText := 0 } )

@ 80, 65 COMBOBOX oCombo VAR cCombo OF oFld1:aDialogs[ 1 ] PIXEL UPDATE ;
ITEMS { "  Line 1", "  Line 2", "  Line 3" } ;
SIZE 50, 60 BITMAPS aBitmaps ; // Width, Height
ON CHANGE MsgBeep()
oCombo:SetColor( 0, 16777215 )
oCombo:SetFont( oFont1 )

@ 130, 65 SAY oSay PROMPT "Transparent Text-test"  OF oFld1:aDialogs[ 1 ] PIXEL UPDATE ;
FONT oFont3 SIZE 95, 12 COLOR 0
oSay:lTransparent := .T.

@ 20, 180 IMAGE oImage SIZE 200, 200  FILENAME NIL OF oFld1:aDialogs[ 1 ] PIXEL NOBORDER UPDATE
oImage:bPainted := { |hDC| DRAW_BMP( oImage, hDC, 4, , , , , "Logo.bmp" ) }

@ 185, 5 GET oGet VAR c1_GradArr OF oFld1:aDialogs[ 1 ] SIZE 315, 28 MULTILINE PIXEL FONT oFont2 UPDATE
oGet:SetColor( 255, 16777215 )

RETURN NIL

// ---------------

FUNCTION SHOW_RGB(oFld1, nPos)
LOCAL oDlg3, oGet, oBtn1, cRGBGrad := "", cTextRGB1 := "", cTextRGB2 := "", nCTop := 0, nCLeft := 0
LOCAL nRed1, nRed2, nGreen1, nGreen2, nBlue1, nBlue2, nGRDStyle := 2, nGradPos := 1, nDiagPos := 0.5, cDirect := ".F."

IF nPos = 1
		nRed1 := nRGBRed( n1_GradC1 )
		nGreen1 := nRGBGreen( n1_GradC1 )
		nBlue1 := nRGBBlue( n1_GradC1 )

		nRed2 := nRGBRed( n1_GradC2 )
		nGreen2 := nRGBGreen( n1_GradC2 )
		nBlue2 := nRGBBlue( n1_GradC2 )

        nGradPos := n1_Gradpos
        nDiagPos :=  n1_DiagPos
		IF l1_GradDir = .T.
				cDirect := ".T."	
		ENDIF
		nGRDStyle := n1_Grad
		nCTop := n1_CircleT
		nCLeft := n1_CircleL
ENDIF
IF nPos = 2
		nRed1 := nRGBRed( n2_GradC1 )
		nGreen1 := nRGBGreen( n2_GradC1 )
		nBlue1 := nRGBBlue( n2_GradC1 )

		nRed2 := nRGBRed( n2_GradC2 )
		nGreen2 := nRGBGreen( n2_GradC2 )
		nBlue2 := nRGBBlue( n2_GradC2 )

        nGradPos := n2_Gradpos
        nDiagPos :=  n2_DiagPos
		IF l2_GradDir = .T.
				cDirect := ".T."	
		ENDIF
		nGRDStyle := n2_Grad
		nCTop := n2_CircleT
		nCLeft := n2_CircleL
ENDIF
IF nPos = 3
		nRed1 := nRGBRed( n3_GradC1 )
		nGreen1 := nRGBGreen( n3_GradC1 )
		nBlue1 := nRGBBlue( n3_GradC1 )

		nRed2 := nRGBRed( n3_GradC2 )
		nGreen2 := nRGBGreen( n3_GradC2 )
		nBlue2 := nRGBBlue( n3_GradC2 )

        nGradPos := n3_Gradpos
        nDiagPos :=  n3_DiagPos
		IF l3_GradDir = .T.
				cDirect := ".T."	
		ENDIF
		nGRDStyle := n3_Grad
		nCTop := n3_CircleT
		nCLeft := n3_CircleL
ENDIF
IF nPos = 4
		nRed1 := nRGBRed( n4_GradC1 )
		nGreen1 := nRGBGreen( n4_GradC1 )
		nBlue1 := nRGBBlue( n4_GradC1 )

		nRed2 := nRGBRed( n4_GradC2 )
		nGreen2 := nRGBGreen( n4_GradC2 )
		nBlue2 := nRGBBlue( n4_GradC2 )

        nGradPos := n4_Gradpos
        nDiagPos :=  n4_DiagPos
		IF l4_GradDir = .T.
				cDirect := ".T."	
		ENDIF
		nGRDStyle := n4_Grad
		nCTop := n4_CircleT
		nCLeft := n4_CircleL
ENDIF
IF nPos = 5
		nRed1 := nRGBRed( n5_GradC1 )
		nGreen1 := nRGBGreen( n5_GradC1 )
		nBlue1 := nRGBBlue( n5_GradC1 )

		nRed2 := nRGBRed( n5_GradC2 )
		nGreen2 := nRGBGreen( n5_GradC2 )
		nBlue2 := nRGBBlue( n5_GradC2 )

        nGradPos := n5_Gradpos
        nDiagPos :=  n5_DiagPos
		IF l5_GradDir = .T.
				cDirect := ".T."	
		ENDIF		
		nGRDStyle := n5_Grad
		nCTop := n5_CircleT
		nCLeft := n5_CircleL
ENDIF

cTextRGB1 := "nRGB( " + ALLTRIM(STR(nRed1)) + ", " + ;
												  ALLTRIM(STR(nGreen1)) + ", " + ;
												  ALLTRIM(STR(nBlue1)) + " )"
cTextRGB2 := "nRGB( " + ALLTRIM(STR(nRed2)) + ", " + ;
												  ALLTRIM(STR(nGreen2)) + ", " + ;
												  ALLTRIM(STR(nBlue2)) + " )"

IF nGRDStyle = 2
		DEFINE DIALOG oDlg3 RESOURCE "SHOWRGB1"  PIXEL ; 
		FONT  oFont TITLE "RGB-translation" OF oFld1 

		cRGBGrad := 	"... "  + CRLF + ;
			                        "ACTIVATE DIALOG oDlg ;" + CRLF + ;
                                    "ON INIT  WD_BACKGRD( oDlg, " + cTextRGB1 + ", " + cTextRGB2 + ", " + ALLTRIM(STR( nGradpos )) + ", " + cDirect  + " )"	+ CRLF + ;	
									" "  + CRLF + ;
									"RETURN NIL"+ CRLF + ;
									" "  + CRLF + ;
									"//  ------------------"  + CRLF + ;
									" "  + CRLF + ;
		                          "FUNCTION WD_BACKGRD( oDlg, ColorF, ColorB, nGradpos, lDirect )" + CRLF + ;
                                  "LOCAL hDC, oBrush" + CRLF + ;
		                          "LOCAL aGrad := { { nGradpos, ColorF, ColorB }, { nGradpos, ColorB, ColorF } }" + CRLF + ;
									" "  + CRLF + ;
									"hDC = CREATECOMPATIBLEDC( oDlg:GetDC() )"  + CRLF + ;
									"hBmp = CREATECOMPATIBLEBITMAP( oDlg:hDC, aRect[4], aRect[3] )"  + CRLF + ;
									"hBmpOld = SELECTOBJECT( hDC, hBmp )"  + CRLF + ;
									"GRADIENTFILL( hDC, 0, 0, aRect[3], aRect[4], aGrad, lDirect ) // .T: = Vertical"  + CRLF + ;
									"oBrush = TBrush():New( ,,,, hBmp )"  + CRLF + ;
									"oDlg:SetBrush( oBrush )"  + CRLF + ;
									"AEVAL( oDlg:aControls, { | oCtl | IF( oCtl:lTransparent, oCtl:SetBrush( oDlg:oBrush ), ) } )"  + CRLF + ;
									"SELECTOBJECT( hDC, hBmpOld )"  + CRLF + ;
									"DELETEDC( hDC )"  + CRLF + ;
									"oDlg:ReleaseDC()"  + CRLF + ;
									" "  + CRLF + ;
									"RELEASE BRUSH oBrush"  + CRLF + ; 
									" "  + CRLF + ;
									"RETURN NIL"
ENDIF
IF nGRDStyle = 1
		DEFINE DIALOG oDlg3 RESOURCE "SHOWRGB2"  PIXEL ; 
		FONT  oFont TITLE "RGB-translation" OF oFld1 

		cRGBGrad := "... "  + CRLF + ;
			                        "ACTIVATE DIALOG oDlg ;" + CRLF + ;
                                    "ON INIT  WD_BACKGRD( oDlg, " + cTextRGB1 + " )"	+ CRLF + ;	
									" "  + CRLF + ;
									"RETURN NIL"+ CRLF + ;
									" "  + CRLF + ;
									"//  ------------------"  + CRLF + ;
									" "  + CRLF + ;
									"FUNCTION WD_BACKGRD( oDlg, ColorF )" + CRLF + ;
                                    "LOCAL oBrush" + CRLF + ;
									" "  + CRLF + ;
									"DEFINE BRUSH oBrush COLOR ColorF"  + CRLF + ;
									" "  + CRLF + ;
									"oDlg:SetBrush( oBrush )"  + CRLF + ;
									"RELEASE BRUSH oBrush"  + CRLF + ; 
									" "  + CRLF + ;
									"RETURN NIL"
ENDIF
IF nGRDStyle = 3
		DEFINE DIALOG oDlg3 RESOURCE "SHOWRGB1"  PIXEL ; 
		FONT  oFont TITLE "RGB-translation" OF oFld1 

		cRGBGrad := "... "  + CRLF + ;
								    "oDlg:bPainted := {|| CIRCLE_GRD( oDlg, " + ALLTRIM(STR(nCTop)) + ", " + ALLTRIM(STR(nCTop)) + " ) }"  + CRLF + ;
									"... "  + CRLF + ;
									"//  ------------------"  + CRLF + ;
									" "  + CRLF + ;
								    "FUNCTION CIRCLE_GRD( oDlg, nCTop, nCLeft )"  + CRLF + ; 
								    "LOCAL aRect := GETCLIENTRECT( oDlg:hWnd )"  + CRLF + ;
								    "LOCAL oBrushDlg := TBrush():New(), nTop := 0, nLeft := 0" + CRLF + ;
									" "  + CRLF + ;
									"IF nCTop > 0"  + CRLF + ;		
									"     nTop := ( aRect[3] / 100 ) * nCTop"  + CRLF + ;
									"ENDIF"  + CRLF + ;
									"IF nCTop < 0"  + CRLF + ;		
									"     nTop := -1 + ( aRect[3] / 100 ) * ( nCTop * 1 )"  + CRLF + ;
									"ENDIF"  + CRLF + ;
									"IF nCLeft > 0"  + CRLF + ;		
									"     nLeft := ( aRect[4] / 100 ) * nCLeft"  + CRLF + ;
									"ENDIF"  + CRLF + ;
									"IF nCLeft < 0"  + CRLF + ;		
									"     nLeft := -1 + ( aRect[4] / 100 ) * ( nCLeft * 1 )"  + CRLF + ; 
									"ENDIF"  + CRLF + ;
									"DeleteObject( oBrushDlg:hBrush )"  + CRLF + ;
									"// hDC, { nTop, nLeft, nBottom, nRight }, startColor, endColor, nOffserX, nOffserY, lBrush"  + CRLF + ;
									"oBrushDlg:hBrush = CircleGradient( 0, aRect , " + cTextRGB1 + ", " + cTextRGB2 + ", nLeft, nTop, 1 )"  + CRLF + ;
									"oDlg:Setbrush( oBrushDlg )"  + CRLF + ;
									"oBrushDlg:End()"  + CRLF + ;
									" "  + CRLF + ;
									"RETURN( NIL )"
ENDIF
IF nGRDStyle = 4
		DEFINE DIALOG oDlg3 RESOURCE "SHOWRGB2"  PIXEL ; 
		FONT  oFont TITLE "RGB-translation" OF oFld1 

			cRGBGrad := "FUNCTION MAIN()"  + CRLF + ;
			"LOCAL oDlg, oBtn1"  + CRLF + ;
									" "  + CRLF + ;
			'DEFINE DIALOG oDlg SIZE 800, 600  PIXEL ;'  + CRLF + ; 
			'FONT  oFont TITLE "DIAGONAL - gradient" '  + CRLF + ;    
			" "  + CRLF + ;
			"oDlg:bPainted := {|hDC| DGRADFILL( hDC, 0, 0, oDlg:nHeight, oDlg:nWidth,;"  + CRLF + ; 
			"     { { 0, " + cTextRGB1 + ", " + cTextRGB2 + " }, ;"  + CRLF + ; 
			"       { 0, " + cTextRGB1 + ", " + cTextRGB2 + " }, ;"  + CRLF + ; 
			"       { " + ALLTRIM(STR(nDiagPos)) + ", " + cTextRGB1 + ", " + cTextRGB2 + " }, ;"  + CRLF + ; 
			"       { " + ALLTRIM(STR(nDiagPos)) + ", " + cTextRGB2 + ", " + cTextRGB1 + " }, ;"  + CRLF + ; 
			"       { 1, " + cTextRGB1 + ", " + cTextRGB1 + " }, ;"  + CRLF + ; 
			"       { 1, " + cTextRGB1 + ", " + cTextRGB1 + " } }, " + cDirect + " ) }"  + CRLF + ; 
			" "  + CRLF + ;
			"ACTIVATE DIALOG oDlg CENTER"  + CRLF + ; 
			" "  + CRLF + ;
 			"RETURN NIL"  
ENDIF

REDEFINE GET oGet  VAR  cRGBGrad ID 110 OF oDlg3 MULTILINE FONT oFont2 UPDATE
oGet:SetColor( 0, 16777215 )

REDEFINE BTNBMP oBtn1 OF oDlg3 ;
ID 70 PIXEL 2007 ; 
NOBORDER ;
PROMPT "&Exit " ;
FILENAME c_path1 + "Exit.Bmp" ;
ACTION oDlg3:End() ;
FONT oFont1 ;
LEFT
oBtn1:bClrGrad = { | lMouseOver | If( ! lMouseOver,;
		{ { 0.50, 6711039, 16777215 }, ;
		{ 0.50, 16777215, 6711039 } }, ;
		{ { 0.50, 16761992, 16777215 }, ;
		{ 0.50, 16777215, 16761992 } } ) }
oBtn1:lTransparent := .t.   
oBtn1:cToolTip =  { "Exit" + CRLF + "Function","EXIT", 1, CLR_BLACK, 14089979 }
oBtn1:SetColor( 0, )

ACTIVATE DIALOG oDlg3 CENTER ;
ON INIT  WD_BACKGRD( oDlg3, 3, , , , , "Marble.bmp" )

RETURN NIL

// --------------------------

FUNCTION F_PAGE2( oFld1 )
LOCAL oGet, oCheck, oRadio, nRadio := 1, lCheck := .T., oImage, oBtn1
LOCAL oCombo, cCombo := "  Line 1"
LOCAL aBitmaps := { c_path1 + "Alert.Bmp",;
                                        c_path1 + "Alert.bmp",;
                                        c_path1 + "Alert.bmp" }

@ 25, 130 CHECKBOX oCheck VAR lCheck PROMPT "&Checkbox" ;
SIZE 50, 20 OF oFld1:aDialogs[ 2 ] PIXEL UPDATE ;
ON CHANGE MsgBeep()
oCheck:SetColor( 0, )
oCheck:SetFont( oFont3 )
oCheck:lTransparent := .T.

@ 30, 60 RADIO oRadio VAR nRadio OF oFld1:aDialogs[ 2 ] ;
ITEMS "&One", "&Two", "T&hree" _3D SIZE 50, 12 PIXEL UPDATE ;
HELPID 100, 101, 102 ;
ON CHANGE MsgBeep()
AEval( oRadio:aItems, { | oRad | oRad:lTransparent := .T., ;
						     oRad:SetFont ( oFont3 ), ;
                             oRad:nClrText := 0 } )

@ 80, 65 COMBOBOX oCombo VAR cCombo OF oFld1:aDialogs[ 2 ] PIXEL UPDATE ;
ITEMS { "  Line 1", "  Line 2", "  Line 3" } ;
SIZE 50, 60 BITMAPS aBitmaps ; // Width, Height
ON CHANGE MsgBeep()
oCombo:SetColor( 0, 16777215 )
oCombo:SetFont( oFont1 )

@ 130, 65 SAY oSay PROMPT "Transparent Text-test"  OF oFld1:aDialogs[ 2 ] PIXEL UPDATE ;
FONT oFont3 SIZE 95, 12 COLOR 0
oSay:lTransparent := .T.

@ 20, 180 IMAGE oImage SIZE 200, 200  FILENAME NIL OF oFld1:aDialogs[ 2 ] PIXEL NOBORDER UPDATE
oImage:bPainted := { |hDC| DRAW_BMP( oImage, hDC, 4, , , , , "Logo.bmp" ) }

@ 185, 5 GET oGet VAR c2_GradArr OF oFld1:aDialogs[ 2 ] SIZE 315, 28 MULTILINE PIXEL FONT oFont2 UPDATE
oGet:SetColor( 255, 16777215 )

RETURN NIL

// --------------------------

FUNCTION F_PAGE3( oFld1 )
LOCAL oGet, oCheck, oRadio, nRadio := 1, lCheck := .T., oImage, oBtn1
LOCAL oCombo, cCombo := "  Line 1"
LOCAL aBitmaps := { c_path1 + "Alert.Bmp",;
                                        c_path1 + "Alert.bmp",;
                                        c_path1 + "Alert.bmp" }

@ 25, 130 CHECKBOX oCheck VAR lCheck PROMPT "&Checkbox" ;
SIZE 50, 20 OF oFld1:aDialogs[ 3 ] PIXEL UPDATE ;
ON CHANGE MsgBeep()
oCheck:SetColor( 0, )
oCheck:SetFont( oFont3 )
oCheck:lTransparent := .T.

@ 30, 60 RADIO oRadio VAR nRadio OF oFld1:aDialogs[ 3 ] ;
ITEMS "&One", "&Two", "T&hree" _3D SIZE 50, 12 PIXEL UPDATE ;
HELPID 100, 101, 102 ;
ON CHANGE MsgBeep()
AEval( oRadio:aItems, { | oRad | oRad:lTransparent := .T., ;
						     oRad:SetFont ( oFont3 ), ;
                             oRad:nClrText := 0 } )

@ 80, 65 COMBOBOX oCombo VAR cCombo OF oFld1:aDialogs[ 3 ] PIXEL UPDATE ;
ITEMS { "  Line 1", "  Line 2", "  Line 3" } ;
SIZE 50, 60 BITMAPS aBitmaps ; // Width, Height
ON CHANGE MsgBeep()
oCombo:SetColor( 0, 16777215 )
oCombo:SetFont( oFont1 )

@ 130, 65 SAY oSay PROMPT "Transparent Text-test"  OF oFld1:aDialogs[ 3 ] PIXEL UPDATE ;
FONT oFont3 SIZE 95, 12 COLOR 0
oSay:lTransparent := .T.

@ 20, 180 IMAGE oImage SIZE 200, 200  FILENAME NIL OF oFld1:aDialogs[ 3 ] PIXEL NOBORDER UPDATE
oImage:bPainted := { |hDC| DRAW_BMP( oImage, hDC, 4, , , , , "Logo.bmp" ) }

@ 185, 5 GET oGet VAR c3_GradArr OF oFld1:aDialogs[ 3 ] SIZE 315, 28 MULTILINE PIXEL FONT oFont2 UPDATE
oGet:SetColor( 255, 16777215 )

RETURN NIL

// --------------------------

FUNCTION F_PAGE4( oFld1 )
LOCAL oGet, oCheck, oRadio, nRadio := 1, lCheck := .T., oImage, oBtn1
LOCAL oCombo, cCombo := "  Line 1"
LOCAL aBitmaps := { c_path1 + "Alert.Bmp",;
                                        c_path1 + "Alert.bmp",;
                                        c_path1 + "Alert.bmp" }

@ 25, 130 CHECKBOX oCheck VAR lCheck PROMPT "&Checkbox" ;
SIZE 50, 20 OF oFld1:aDialogs[ 4 ] PIXEL UPDATE ;
ON CHANGE MsgBeep()
oCheck:SetColor( 0, )
oCheck:SetFont( oFont3 )
oCheck:lTransparent := .T.

@ 30, 60 RADIO oRadio VAR nRadio OF oFld1:aDialogs[ 4 ] ;
ITEMS "&One", "&Two", "T&hree" _3D SIZE 50, 12 PIXEL UPDATE ;
HELPID 100, 101, 102 ;
ON CHANGE MsgBeep()
AEval( oRadio:aItems, { | oRad | oRad:lTransparent := .T., ;
						     oRad:SetFont ( oFont3 ), ;
                             oRad:nClrText := 0 } )

@ 80, 65 COMBOBOX oCombo VAR cCombo OF oFld1:aDialogs[ 4 ] PIXEL UPDATE ;
ITEMS { "  Line 1", "  Line 2", "  Line 3" } ;
SIZE 50, 60 BITMAPS aBitmaps ; // Width, Height
ON CHANGE MsgBeep()
oCombo:SetColor( 0, 16777215 )
oCombo:SetFont( oFont1 )

@ 130, 65 SAY oSay PROMPT "Transparent Text-test"  OF oFld1:aDialogs[ 4 ] PIXEL UPDATE ;
FONT oFont3 SIZE 95, 12 COLOR 0
oSay:lTransparent := .T.

@ 20, 180 IMAGE oImage SIZE 200, 200  FILENAME NIL OF oFld1:aDialogs[ 4 ] PIXEL NOBORDER UPDATE
oImage:bPainted := { |hDC| DRAW_BMP( oImage, hDC, 4, , , , , "Logo.bmp" ) }

@ 185, 5 GET oGet VAR c4_GradArr OF oFld1:aDialogs[ 4 ] SIZE 315, 28 MULTILINE PIXEL FONT oFont2 UPDATE
oGet:SetColor( 255, 16777215 )

RETURN NIL

// --------------------------

FUNCTION F_PAGE5( oFld1 )
LOCAL oGet, oCheck, oRadio, nRadio := 1, lCheck := .T., oImage, oBtn1
LOCAL oCombo, cCombo := "  Line 1"
LOCAL aBitmaps := { c_path1 + "Alert.Bmp",;
                                        c_path1 + "Alert.bmp",;
                                        c_path1 + "Alert.bmp" }

@ 25, 130 CHECKBOX oCheck VAR lCheck PROMPT "&Checkbox" ;
SIZE 50, 20 OF oFld1:aDialogs[ 5 ] PIXEL UPDATE ;
ON CHANGE MsgBeep()
oCheck:SetColor( 0, )
oCheck:SetFont( oFont3 )
oCheck:lTransparent := .T.

@ 30, 60 RADIO oRadio VAR nRadio OF oFld1:aDialogs[ 5 ] ;
ITEMS "&One", "&Two", "T&hree" _3D SIZE 50, 12 PIXEL UPDATE ;
HELPID 100, 101, 102 ;
ON CHANGE MsgBeep()
AEval( oRadio:aItems, { | oRad | oRad:lTransparent := .T., ;
						     oRad:SetFont ( oFont3 ), ;
                             oRad:nClrText := 0 } )

@ 80, 65 COMBOBOX oCombo VAR cCombo OF oFld1:aDialogs[ 5 ] PIXEL UPDATE ;
ITEMS { "  Line 1", "  Line 2", "  Line 3" } ;
SIZE 50, 60 BITMAPS aBitmaps ; // Width, Height
ON CHANGE MsgBeep()
oCombo:SetColor( 0, 16777215 )
oCombo:SetFont( oFont1 )

@ 130, 65 SAY oSay PROMPT "Transparent Text-test"  OF oFld1:aDialogs[ 5 ] PIXEL UPDATE ;
FONT oFont3 SIZE 95, 12 COLOR 0
oSay:lTransparent := .T.

@ 20, 180 IMAGE oImage SIZE 200, 200  FILENAME NIL OF oFld1:aDialogs[ 5 ] PIXEL NOBORDER UPDATE
oImage:bPainted := { |hDC| DRAW_BMP( oImage, hDC, 4, , , , , "Logo.bmp" ) }

@ 185, 5 GET oGet VAR c5_GradArr OF oFld1:aDialogs[ 5 ] SIZE 315, 28 MULTILINE PIXEL FONT oFont2 UPDATE
oGet:SetColor( 255, 16777215 )

RETURN NIL

// ----------------

FUNCTION GET_ARRAY(oFld1)

IF n1_Grad = 1
		c1_GradArr := "DEFINE BRUSH oBrush COLOR " + ALLTRIM(STR(	n1_GradC1 ))	
ENDIF
IF n1_Grad = 2
		c1_GradArr := "aGrad := { { " + ;
									ALLTRIM(STR(n1_GradPos)) + ", " + ;
									ALLTRIM(STR(n1_GradC1)) + ", " + ;
									ALLTRIM(STR(n1_GradC2)) + " }, { " + ;
									ALLTRIM(STR(n1_GradPos)) + ", " + ;
									ALLTRIM(STR(n1_GradC2)) + ", " + ;
									ALLTRIM(STR(n1_GradC1)) + " } }"		
ENDIF
IF n1_Grad = 3
		c1_GradArr := "oBrush:hBrush = CircleGradient( 0, aRect , " + ALLTRIM(STR(n1_GradC1)) + ", " + ALLTRIM(STR(n1_GradC1)) + ;
				                                                                                             ", " + ALLTRIM(STR(n1_CircleL)) + ", " + ALLTRIM(STR(n1_CircleT)) + ", 1 )" 
ENDIF
IF n1_Grad = 4
		cDirect := ".F."
		IF l1_DiagDir = .T.
				cDirect := ".T."
		ENDIF
		c1_GradArr := "DGRADFILL( hDC, 0, 0, oDlg:nHeight, oDlg:nWidth, ;" + CRLF + ;
                                 "{ { 0, " + ALLTRIM(STR(n1_GradC1 )) + ", " + ALLTRIM(STR( n1_GradC1 )) + " }, " + ;
                                   "{ 0, " + ALLTRIM(STR(n1_GradC1 )) + ", " + ALLTRIM(STR( n1_GradC1 )) + " }, "  + ;
                                   "{ " + ALLTRIM(STR( n1_DiagPos )) + ", " + ALLTRIM(STR( n1_GradC1 )) + ", " + ALLTRIM(STR( n1_GradC2 )) + " }, ;" + CRLF + ;
                                   "{ " + ALLTRIM(STR( n1_DiagPos )) + ", " + ALLTRIM(STR( n1_GradC2 )) + ", " + ALLTRIM(STR( n1_GradC1 )) + " }, " + ;
                                   "{ 1, " + ALLTRIM(STR( n1_GradC1 )) + ", " + ALLTRIM(STR( n1_GradC1 )) + " }, " + ;
                                   "{ 1, " + ALLTRIM(STR( n1_GradC1 )) + ", " + ALLTRIM(STR( n1_GradC1 )) + " } }, " + cDirect + " ) "
ENDIF
IF n2_Grad = 1
		c2_GradArr := "DEFINE BRUSH oBrush COLOR " + ALLTRIM(STR(	n3_GradC1 ))	
ENDIF
IF n2_Grad = 2
		c2_GradArr := "aGrad := { { " + ;
									ALLTRIM(STR(n2_GradPos)) + ", " + ;
									ALLTRIM(STR(n2_GradC1)) + ", " + ;
									ALLTRIM(STR(n2_GradC2)) + " }, { " + ;
									ALLTRIM(STR(n2_GradPos)) + ", " + ;
									ALLTRIM(STR(n2_GradC2)) + ", " + ;
									ALLTRIM(STR(n2_GradC1)) + " } }"		
ENDIF
IF n2_Grad = 3
		c2_GradArr := "oBrush:hBrush = CircleGradient( 0, aRect , " + ALLTRIM(STR(n2_GradC1)) + ", " + ALLTRIM(STR(n2_GradC1)) + ;
				                                                                                             ", " + ALLTRIM(STR(n2_CircleL)) + ", " + ALLTRIM(STR(n2_CircleT)) + ", 1 )" 
ENDIF
IF n2_Grad = 4
		cDirect := ".F."
		IF l2_DiagDir = .T.
				cDirect := ".T."
		ENDIF
		c2_GradArr := "DGRADFILL( hDC, 0, 0, oDlg:nHeight, oDlg:nWidth, ;" + CRLF + ;
                                 "{ { 0, " + ALLTRIM(STR(n2_GradC1 )) + ", " + ALLTRIM(STR( n2_GradC1 )) + " }, " + ;
                                   "{ 0, " + ALLTRIM(STR(n2_GradC1 )) + ", " + ALLTRIM(STR( n2_GradC1 )) + " }, "  + ;
                                   "{ " + ALLTRIM(STR( n2_DiagPos )) + ", " + ALLTRIM(STR( n2_GradC1 )) + ", " + ALLTRIM(STR( n2_GradC2 )) + " }, ;" + CRLF + ;
                                   "{ " + ALLTRIM(STR( n2_DiagPos )) + ", " + ALLTRIM(STR( n2_GradC2 )) + ", " + ALLTRIM(STR( n2_GradC1 )) + " }, " + ;
                                   "{ 1, " + ALLTRIM(STR( n2_GradC1 )) + ", " + ALLTRIM(STR( n2_GradC1 )) + " }, " + ;
                                   "{ 1, " + ALLTRIM(STR( n2_GradC1 )) + ", " + ALLTRIM(STR( n2_GradC1 )) + " } }, " + cDirect + " ) "
ENDIF

IF n3_Grad = 1
		c3_GradArr := "DEFINE BRUSH oBrush COLOR " + ALLTRIM(STR(	n3_GradC1 ))	
ENDIF
IF n3_Grad = 2
		c3_GradArr := "aGrad := { { " + ;
									ALLTRIM(STR(n3_GradPos)) + ", " + ;
									ALLTRIM(STR(n3_GradC1)) + ", " + ;
									ALLTRIM(STR(n3_GradC2)) + " }, { " + ;
									ALLTRIM(STR(n3_GradPos)) + ", " + ;
									ALLTRIM(STR(n3_GradC2)) + ", " + ;
									ALLTRIM(STR(n3_GradC1)) + " } }"		
ENDIF
IF n3_Grad = 3
		c3_GradArr := "oBrush:hBrush = CircleGradient( 0, aRect , " + ALLTRIM(STR(n3_GradC1)) + ", " + ALLTRIM(STR(n3_GradC1)) + ;
				                                                                                             ", " + ALLTRIM(STR(n3_CircleL)) + ", " + ALLTRIM(STR(n3_CircleT)) + ", 1 )" 
ENDIF
IF n3_Grad = 4
		cDirect := ".F."
		IF l3_DiagDir = .T.
				cDirect := ".T."
		ENDIF
		c3_GradArr := "DGRADFILL( hDC, 0, 0, oDlg:nHeight, oDlg:nWidth, ;" + CRLF + ;
                                 "{ { 0, " + ALLTRIM(STR(n3_GradC1 )) + ", " + ALLTRIM(STR( n3_GradC1 )) + " }, " + ;
                                   "{ 0, " + ALLTRIM(STR(n3_GradC1 )) + ", " + ALLTRIM(STR( n3_GradC1 )) + " }, "  + ;
                                   "{ " + ALLTRIM(STR( n3_DiagPos )) + ", " + ALLTRIM(STR( n3_GradC1 )) + ", " + ALLTRIM(STR( n3_GradC2 )) + " }, ;" + CRLF + ;
                                   "{ " + ALLTRIM(STR( n3_DiagPos )) + ", " + ALLTRIM(STR( n3_GradC2 )) + ", " + ALLTRIM(STR( n3_GradC1 )) + " }, " + ;
                                   "{ 1, " + ALLTRIM(STR( n3_GradC1 )) + ", " + ALLTRIM(STR( n3_GradC1 )) + " }, " + ;
                                   "{ 1, " + ALLTRIM(STR( n3_GradC1 )) + ", " + ALLTRIM(STR( n3_GradC1 )) + " } }, " + cDirect + " ) "
ENDIF
IF n4_Grad = 1
		c4_GradArr := "DEFINE BRUSH oBrush COLOR " + ALLTRIM(STR(	n4_GradC1 ))	
ENDIF
IF n4_Grad = 2
		c4_GradArr := "aGrad := { { " + ;
									ALLTRIM(STR(n4_GradPos)) + ", " + ;
									ALLTRIM(STR(n4_GradC1)) + ", " + ;
									ALLTRIM(STR(n4_GradC2)) + " }, { " + ;
									ALLTRIM(STR(n4_GradPos)) + ", " + ;
									ALLTRIM(STR(n4_GradC2)) + ", " + ;
									ALLTRIM(STR(n4_GradC1)) + " } }"		
ENDIF
IF n4_Grad = 3
		c4_GradArr := "oBrush:hBrush = CircleGradient( 0, aRect , " + ALLTRIM(STR(n4_GradC1)) + ", " + ALLTRIM(STR(n4_GradC1)) + ;
				                                                                                             ", " + ALLTRIM(STR(n4_CircleL)) + ", " + ALLTRIM(STR(n4_CircleT)) + ", 1 )" 
ENDIF
IF n4_Grad = 4
		cDirect := ".F."
		IF l4_DiagDir = .T.
				cDirect := ".T."
		ENDIF
		c4_GradArr := "DGRADFILL( hDC, 0, 0, oDlg:nHeight, oDlg:nWidth, ;" + CRLF + ;
                                 "{ { 0, " + ALLTRIM(STR(n4_GradC1 )) + ", " + ALLTRIM(STR( n4_GradC1 )) + " }, " + ;
                                   "{ 0, " + ALLTRIM(STR(n4_GradC1 )) + ", " + ALLTRIM(STR( n4_GradC1 )) + " }, "  + ;
                                   "{ " + ALLTRIM(STR( n4_DiagPos )) + ", " + ALLTRIM(STR( n4_GradC1 )) + ", " + ALLTRIM(STR( n4_GradC2 )) + " }, ;" + CRLF + ;
                                   "{ " + ALLTRIM(STR( n4_DiagPos )) + ", " + ALLTRIM(STR( n4_GradC2 )) + ", " + ALLTRIM(STR( n4_GradC1 )) + " }, " + ;
                                   "{ 1, " + ALLTRIM(STR( n4_GradC1 )) + ", " + ALLTRIM(STR( n4_GradC1 )) + " }, " + ;
                                   "{ 1, " + ALLTRIM(STR( n4_GradC1 )) + ", " + ALLTRIM(STR( n4_GradC1 )) + " } }, " + cDirect + " ) "
ENDIF
IF n5_Grad = 1
		c5_GradArr := "DEFINE BRUSH oBrush COLOR " + ALLTRIM(STR(	n5_GradC1 ))	
ENDIF
IF n5_Grad = 2
		c5_GradArr := "aGrad := { { " + ;
									ALLTRIM(STR(n5_GradPos)) + ", " + ;
									ALLTRIM(STR(n5_GradC1)) + ", " + ;
									ALLTRIM(STR(n5_GradC2)) + " }, { " + ;
									ALLTRIM(STR(n5_GradPos)) + ", " + ;
									ALLTRIM(STR(n5_GradC2)) + ", " + ;
									ALLTRIM(STR(n5_GradC1)) + " } }"		
ENDIF
IF n5_Grad = 3
		c5_GradArr := "oBrush:hBrush = CircleGradient( 0, aRect , " + ALLTRIM(STR(n5_GradC1)) + ", " + ALLTRIM(STR(n5_GradC1)) + ;
				                                                                                             ", " + ALLTRIM(STR(n5_CircleL)) + ", " + ALLTRIM(STR(n5_CircleT)) + ", 1 )" 
ENDIF
IF n5_Grad = 4
		cDirect := ".F."
		IF l5_DiagDir = .T.
				cDirect := ".T."
		ENDIF
		c5_GradArr := "DGRADFILL( hDC, 0, 0, oDlg:nHeight, oDlg:nWidth, ;" + CRLF + ;
                                 "{ { 0, " + ALLTRIM(STR(n5_GradC1 )) + ", " + ALLTRIM(STR( n5_GradC1 )) + " }, " + ;
                                   "{ 0, " + ALLTRIM(STR(n5_GradC1 )) + ", " + ALLTRIM(STR( n5_GradC1 )) + " }, "  + ;
                                   "{ " + ALLTRIM(STR( n5_DiagPos )) + ", " + ALLTRIM(STR( n5_GradC1 )) + ", " + ALLTRIM(STR( n5_GradC2 )) + " }, ; " + CRLF + ;
                                   "{ " + ALLTRIM(STR( n5_DiagPos )) + ", " + ALLTRIM(STR( n5_GradC2 )) + ", " + ALLTRIM(STR( n5_GradC1 )) + " }, " + ;
                                   "{ 1, " + ALLTRIM(STR( n5_GradC1 )) + ", " + ALLTRIM(STR( n5_GradC1 )) + " }, " + ;
                                   "{ 1, " + ALLTRIM(STR( n5_GradC1 )) + ", " + ALLTRIM(STR( n5_GradC1 )) + " } }, " + cDirect + " ) "
ENDIF
oFld1:Update()

RETURN NIL

// ---------------------

FUNCTION PaintTab( o, nOption )

IF nOption == o:nOver .OR. nOption == o:nOption
		o:SetAlphaLevel( nOption, 255 )
ELSE 
		o:SetAlphaLevel( nOption, 50 )
ENDIF 
   
RETURN o:SetFldColors( o, nOption )    

// --------  FOLDER - Gradient ---------------

FUNCTION FLD_GRAD( oFld1 ) 
LOCAL n, oDlg, hDC, oBrush, hBmp, hBmpOld, aGrad := {}, nColor1, nColor2, lDirect
LOCAL aRect := GETCLIENTRECT( oFld1:hWnd ), nStyle := 1, nGRDStyle := 1, nDiagonal := 0.5
LOCAL oFldBrush, nGrdPos := 0.5, nCTop := 0, nCLeft := 0, nTop := 0, nLeft := 0

FOR n := 1 to Len( oFld1:aDialogs ) 

		oDlg := oFld1:aDialogs[ n ]

		IF n = 1 
				nColor1 := n1_GradC1
				nColor2 := n1_GradC2
				lDirect := l1_GradDir
                lDiagDir := l1_DiagDir
				nGrdPos := n1_Gradpos
                nDiagonal := n1_DiagPos 
				nCTop := n1_CircleT
				nCLeft := n1_CircleL
				nGRDStyle := n1_Grad
		ENDIF
		IF n = 2 
				nColor1 := n2_GradC1
				nColor2 := n2_GradC2
				lDirect := l2_GradDir
                lDiagDir := l2_DiagDir
				nGrdPos := n2_Gradpos
                nDiagonal := n2_DiagPos  
				nCTop := n2_CircleT
				nCLeft := n2_CircleL
				nGRDStyle := n2_Grad
		ENDIF
		IF n = 3 
				nColor1 := n3_GradC1
				nColor2 := n3_GradC2
				lDirect := l3_GradDir
                lDiagDir := l3_DiagDir
				nGrdPos := n3_Gradpos
                nDiagonal := n3_DiagPos  
				nCTop := n3_CircleT
				nCLeft := n3_CircleL
				nGRDStyle := n3_Grad
		ENDIF
		IF n = 4 
				nColor1 := n4_GradC1
				nColor2 := n4_GradC2
				lDirect := l4_GradDir
                lDiagDir := l4_DiagDir
				nGrdPos := n4_Gradpos
                nDiagonal := n4_DiagPos  
				nCTop := n4_CircleT
				nCLeft := n4_CircleL
				nGRDStyle := n4_Grad
		ENDIF
		IF n = 5 
				nColor1 := n5_GradC1
				nColor2 := n5_GradC2
				lDirect := l5_GradDir
                lDiagDir := l5_DiagDir
				nGrdPos := n5_Gradpos
                nDiagonal := n5_DiagPos  
				nCTop := n5_CircleT
				nCLeft := n5_CircleL
				nGRDStyle := n5_Grad	
		ENDIF
		IF nGRDStyle < 3
				IF nGRDStyle = 1
						aGrad := { { nGrdPos, nColor1, nColor1 }, { nGrdPos, nColor1, nColor1 } }
				ENDIF
				IF nGRDStyle = 2
						aGrad := { { nGrdPos, nColor1, nColor2 }, { nGrdPos, nColor2, nColor1 } }
				ENDIF
				hDC = CreateCompatibleDC( oDlg:GetDC() )
				hBmp = CreateCompatibleBitMap( oDlg:hDC, aRect[4], aRect[3] )
				hBmpOld = SelectObject( hDC, hBmp )
				GRADIENTFILL( hDC, 0, 0, aRect[3], aRect[4], aGrad, lDirect )
				oDlg:oBrush := TBrush():New()
				oDlg:oBrush:hBitmap := hBmp
				oDlg:oBrush:hBrush := CreatePatternBrush( hBmp )
				SelectObject( hDC, hBmpOld )
				oDlg:ReleaseDC()
				AEVAL( oDlg:aControls, { | oCtl | If( oCtl:lTransparent, oCtl:SetBrush( oDlg:oBrush ), ) } )
		ENDIF
		IF nGRDStyle = 3
				oFldBrush := TBrush():New()
				IF nCTop > 0		
						nTop := ( aRect[3] / 100 ) * nCTop
				ENDIF
				IF nCTop < 0		
						nTop := -1 + ( aRect[3] / 100 ) * ( nCTop * 1 )
				ENDIF
				IF nCLeft > 0		
						nLeft := ( aRect[4] / 100 ) * nCLeft
				ENDIF
				IF nCLeft < 0		
						nLeft := -1 + ( aRect[4] / 100 ) * ( nCLeft * 1 ) 
				ENDIF
                
				// hDC, { nTop, nLeft, nBottom, nRight }, startColor, endColor, nOffserX, nOffserY, lBrush --> hBitmap / hBrush
				DeleteObject( oFldBrush:hBrush )
				oFldBrush:hBrush := CircleGradient( 0, aRect , nColor1, nColor2, nLeft, nTop, 1 )
				oDlg:Setbrush( oFldBrush )
				oFldBrush:End()
				AEVAL( oDlg:aControls, { | oCtl | If( oCtl:lTransparent, oCtl:SetBrush( oDlg:oBrush ), ) } )
		ENDIF
		IF nGRDStyle = 4
				hDC = CreateCompatibleDC( oDlg:GetDC() )
				hBmp = CreateCompatibleBitMap( oDlg:hDC, oDlg:nWidth, oDlg:nHeight )
				hBmpOld = SelectObject( hDC, hBmp )
				
				// DGRADFILL( hDC, nTop, nLeft, nBottom, nRight, aGradInfo, lDirection )
	
				// MsgAlert( nColor1, "Folder Color 1" )
				// MsgAlert( nColor1, "Folder Color 2" )
				// MsgAlert( nDiagonal, "Folder Position" )
				// MsgAlert( lDiagDir, "Folder Direction" )

				DGRADFILL( hDC, 0, 0, aRect[3], aRect[4],;
                                 { { 0, nColor1, nColor1 }, { 0, nColor1, nColor1 }, ;
                                   { nDiagonal, nColor1, nColor2 }, ;
                                   { nDiagonal, nColor2, nColor1 }, ;
                                   { 1, nColor1, nColor1 }, { 1, nColor1, nColor1 } }, lDiagDir ) 

				oDlg:oBrush := TBrush():New()
				oDlg:oBrush:hBitmap := hBmp
				oDlg:oBrush:hBrush := CreatePatternBrush( hBmp )
				SelectObject( hDC, hBmpOld )
				oDlg:ReleaseDC()
				AEVAL( oDlg:aControls, { | oCtl | If( oCtl:lTransparent, oCtl:SetBrush( oDlg:oBrush ), ) } )
		ENDIF
NEXT

oDlg:Update()

RETURN( NIL )

// --------------------

FUNCTION LOAD_PROJECT( oDlg1, oFld1 ) 
LOCAL oDlg3, oData, oStru, oBrush, oBar1, oBtn1, oBtn2, oBtn3, oBtn4, oBtn5, oBtn6
LOCAL oGet1, oGet2, oSelex1, nKeepline := 1, nStrucRow := 1, oSeek, oGrd[6]

lNewproj := .F.

DEFINE DIALOG oDlg3 SIZE 700, 390 ;
TITLE "PROJECT - selection"  OF oDlg1 FONT oFont

DBSELECTAREA("SET") 
LOAD_DBF(oDlg3)

@ 10,10 XBROWSE oData  SIZE 330, 108  OF oDlg3 PIXEL AUTOSORT ;
DATASOURCE "SET" COLUMNS "cPROJECT", "LSELECTED" ;
ON CHANGE ( LOAD_DBF(oDlg), oDlg3:Update() )

oData:nMarqueeStyle			:=  MARQSTYLE_HIGHLROW
oData:nColDividerStyle		:= LINESTYLE_BLACK
oData:nRowDividerStyle		:= LINESTYLE_BLACK
oData:lHScroll							:= .F.
oData:lVScroll							:= .T.
oData:lFooter							:= .T.
oData:nHeaderHeight			:= 30
oData:nFooterHeight			:= 30
oData:nRowHeight				:= 25
oData:oFont							:= oFont1

oCol := oData:AddCol()
oData:aCols[ 1 ]:cHeader			:= "P R O J E C T"
oData:aCols[ 1 ]:addbmpfile( c_path1 + "Info.bmp" ) // from Disk
oData:aCols[ 1 ]:nFootBmpNo	:= 1 // Footer BMP
oData:aCols[ 1 ]:nWidth				:= 170
oData:aCols[ 1 ]:bEditValue		:= { || ("SET")->cPROJECT }
oData:aCols[ 1 ]:nEditType			:= EDIT_GET 
oData:aCols[ 1 ]:bOnPostEdit	:= { | oCol, xVal, nKey | IIF( nKey == VK_RETURN, ;
													          ( DBSELECTAREA("SET"), ;
													             NET_RLOCK( 3, 3 ), ;
													             ("SET")->cPROJECT := xVal, ;
													             NET_ULOCK(), oData:Refresh() ), ;
																MsgAlert( "Old data : " + CRLF + ;
														                   ALLTRIM(("SET")->cPROJECT) + CRLF + ;
																   "not changed !!!", "ERROR" ) ) } 

oCol := oData:AddCol()
oData:aCols[ 2 ]:cHeader		:= "START"
oData:aCols[ 2 ]:nHeadStrAlign	:= AL_CENTER
oData:aCols[ 2 ]:addbmpfile( c_path1 + "Checkon.bmp" ) // from Disk
oData:aCols[ 2 ]:addbmpfile( c_path1 + "Checkoff.bmp" ) // from Disk
oData:aCols[ 2 ]:addbmpfile( c_path1 + "Info.bmp" ) // from Disk
oData:aCols[ 2 ]:bBmpData	:= {|| IIF( ("SET")->LSELECTED = .T., 1, 2 ) }
oData:aCols[ 2 ]:bAlphaLevel := { || IF( ("SET")->( DELETED() ) , 60, 255 ) }
oData:aCols[ 2 ]:bEditValue	:= { || NIL }
oData:aCols[ 2 ]:nFootBmpNo	:= 3 // Footer BMP
oData:aCols[ 2 ]:nWidth			:= 52
oData:aCols[ 2 ]:bToolTip		:= {| oData, nRow, nCol, nKeyFlag | ;
										IF( oData:MouseRowPos(nRow) == oData:nRowSel, ;
											"PROJECT-START" + CRLF + ;
											+ CRLF + ;
											"switch < Y / N > " + CRLF + ;
											"with right" + CRLF + ;
											"mouseclick", ) }

oCol := oData:AddCol()
oData:aCols[ 3 ]:cHeader		:= "Numeric"
oData:aCols[ 3 ]:nHeadStrAlign	:= AL_CENTER
oData:aCols[ 3 ]:nDataStrAlign	:= AL_RIGHT
oData:aCols[ 3 ]:bStrData		:= { || ("SET")->nValRGB }
oData:aCols[ 3 ]:nWidth			:= 70

oCol := oData:AddCol()
oData:aCols[ 4 ]:cHeader		:= "RGB"
oData:aCols[ 4 ]:nHeadStrAlign	:= AL_CENTER
oData:aCols[ 4 ]:nDataStrAlign	:= AL_CENTER
oData:aCols[ 4 ]:bEditValue	:= { || ("SET")->cTextRGB }
oData:aCols[ 4 ]:nWidth			:= 140

oCol := oData:AddCol()
oData:aCols[ 5 ]:cHeader		:= "Word"
oData:aCols[ 5 ]:nHeadStrAlign	:= AL_CENTER
oData:aCols[ 5 ]:nDataStrAlign	:= AL_CENTER
oData:aCols[ 5 ]:bEditValue	:= { || ("SET")->cWordRGB }
oData:aCols[ 5 ]:nWidth			:= 120
 
oCol := oData:AddCol()
oData:aCols[ 6 ]:cHeader		:= "Bright"
oData:aCols[ 6 ]:nHeadStrAlign	:= AL_CENTER
oData:aCols[ 6 ]:nDataStrAlign	:= AL_CENTER
oData:aCols[ 6 ]:bEditValue	:= { || ("SET")->nBrightRGB }
oData:aCols[ 6 ]:nWidth			:= 50

oData:bRClicked := { || ( nRPos := oData:KeyNo(), ;
											  nCPos := oData:SelectedCol():nCreationOrder, ;
											  CLEAR_SEL(oData) ) }

WITH OBJECT oData
        :lIncrFilter := .T.
		:bClrStd := { || If( oData:KeyNo() % 2 == 0, ;
								{ If( ( oData:cAlias )->( Deleted() ), 255, 0 ), 16772313 }, ;
								{ If( ( oData:cAlias )->( Deleted() ), 255, 0 ), 16766378 } ) }
		:lColChangeNotify	:= .T.
		:bChange				:= { || LOAD_DBF(oDlg3), ;
												 oGrd[1]:Refresh(), oGrd[2]:Refresh(), oGrd[3]:Refresh(), ;
												 oGrd[4]:Refresh(), oGrd[5]:Refresh() }
		:CreateFromCode()
END

@  125, 40 TITLE oGrd[1] SIZE 45, 30 PIXEL OF oDlg3 ;
ROUND BORDER SHADOWSIZE 0 UPDATE 
oGrd[1]:bPainted := { |hDC| ( IIF( n1_Grad = 1, DRAW_BMP( oGrd[1], hDC, 1, n1_GradC1, n1_GradC1, l1_GradDir, n1_Gradpos ), NIL ), ;
                                                       IIF( n1_Grad = 2, DRAW_BMP( oGrd[1], hDC, 2, n1_GradC1, n1_GradC2, l1_GradDir, n1_Gradpos ), NIL ), ;
                                                       IIF( n1_Grad = 3, T_CIRCLE( oGrd[1], hDC, n1_GradC1, n1_GradC2, n1_CircleT, n1_CircleL, 1 ), NIL ), ;
                                                       IIF( n1_Grad = 4, T_DIAGONAL( oGrd[1], hDC, n1_GradC1, n1_GradC2, n1_DiagPos, l1_DiagDir, 1 ), NIL ) ) }

@  125, 95 TITLE oGrd[2] SIZE 45, 30 PIXEL OF oDlg3 ;
ROUND BORDER SHADOWSIZE 0 UPDATE 
oGrd[2]:bPainted := { |hDC| ( IIF( n2_Grad = 1, DRAW_BMP( oGrd[2], hDC, 1, n2_GradC1, n2_GradC1, l2_GradDir, n2_Gradpos ), NIL ), ;
                                                       IIF( n2_Grad = 2, DRAW_BMP( oGrd[2], hDC, 2, n2_GradC1, n2_GradC2, l2_GradDir, n2_Gradpos ), NIL ), ;
                                                       IIF( n2_Grad = 3, T_CIRCLE( oGrd[2], hDC, n2_GradC1, n2_GradC2, n2_CircleT, n2_CircleL, 2 ), NIL ), ;
                                                       IIF( n2_Grad = 4, T_DIAGONAL( oGrd[2], hDC, n2_GradC1, n2_GradC2, n2_DiagPos, l2_DiagDir, 2 ), NIL ) ) }

@  125, 150 TITLE oGrd[3] SIZE 45, 30 PIXEL OF oDlg3 ;
ROUND BORDER SHADOWSIZE 0 UPDATE 
oGrd[3]:bPainted := { |hDC| ( IIF( n3_Grad = 1, DRAW_BMP( oGrd[3], hDC, 1, n3_GradC1, n3_GradC1, l3_GradDir, n3_Gradpos ), NIL ), ;
                                                       IIF( n3_Grad = 2, DRAW_BMP( oGrd[3], hDC, 2, n3_GradC1, n3_GradC2, l3_GradDir, n3_Gradpos ), NIL ), ;
                                                       IIF( n3_Grad = 3, T_CIRCLE( oGrd[3], hDC, n3_GradC1, n3_GradC2, n3_CircleT, n3_CircleL, 3 ), NIL ), ;
                                                       IIF( n3_Grad = 4, T_DIAGONAL( oGrd[3], hDC, n3_GradC1, n3_GradC2, n3_DiagPos, l3_DiagDir, 3 ), NIL ) ) }

@  125, 205 TITLE oGrd[4] SIZE 45, 30 PIXEL OF oDlg3 ;
ROUND BORDER SHADOWSIZE 0 UPDATE 
oGrd[4]:bPainted := { |hDC| ( IIF( n4_Grad = 1, DRAW_BMP( oGrd[4], hDC, 1, n4_GradC1, n4_GradC1, l2_GradDir, n4_Gradpos ), NIL ), ;
                                                       IIF( n4_Grad = 2, DRAW_BMP( oGrd[4], hDC, 2, n4_GradC1, n4_GradC2, l2_GradDir, n4_Gradpos ), NIL ), ;
                                                       IIF( n4_Grad = 3, T_CIRCLE( oGrd[4], hDC, n4_GradC1, n4_GradC2, n4_CircleT, n4_CircleL, 4 ), NIL ), ;
                                                       IIF( n4_Grad = 4, T_DIAGONAL( oGrd[4], hDC, n4_GradC1, n4_GradC2, n4_DiagPos, l4_DiagDir, 4 ), NIL ) ) }

@  125, 260 TITLE oGrd[5] SIZE 45, 30 PIXEL OF oDlg3 ;
ROUND BORDER SHADOWSIZE 0 UPDATE 
oGrd[5]:bPainted := { |hDC| ( IIF( n5_Grad = 1, DRAW_BMP( oGrd[5], hDC, 1, n5_GradC1, n5_GradC1, l5_GradDir, n5_Gradpos ), NIL ), ;
                                                       IIF( n5_Grad = 2, DRAW_BMP( oGrd[5], hDC, 2, n5_GradC1, n5_GradC2, l5_GradDir, n5_Gradpos ), NIL ), ;
                                                       IIF( n5_Grad = 3, T_CIRCLE( oGrd[5], hDC, n5_GradC1, n5_GradC2, n5_CircleT, n5_CircleL, 5 ), NIL ), ;
                                                       IIF( n5_Grad = 4, T_DIAGONAL( oGrd[5], hDC, n5_GradC1, n5_GradC2, n5_DiagPos, l5_DiagDir, 5 ), NIL ) ) }

@ 170, 75 SAY oSeek PROMPT "Seek project" SIZE 70, 12 OF oDlg3 PIXEL FONT oFont1		  
oSeek:Setcolor( nDTxtColor,  )
oSeek:lTransparent := .T.

@ 165, 115 SAY oData:oSeek PROMPT oData:cSeek SIZE 70, 12 OF oDlg3 PIXEL FONT oFont1		  
oData:oSeek:Setcolor( 255, 16772313  )

@ 165, 205 BTNBMP oBtn3 OF oDlg3 ;
SIZE 55, 22 PIXEL 2007 ;
ROUND NOBORDER ;
PROMPT " &Select    " ;
FILENAME c_path1 + "Select.Bmp" ;
ACTION ( lNewProj := .T., ;
				  cBrwPos := ("SET")->cPROJECT, ;
				  nBrwPos := oData:KeyNo(), ; 
                  LOAD_DBF(oDlg3), GET_ARRAY(oFld1), ;
                  oDlg3:End() ) ;
FONT oFont1 ;
LEFT
oBtn3:bClrGrad = { | lMouseOver | If( ! lMouseOver,;
	{ { 0.50, 3067734, 16777215 }, ;
	{ 0.50, 16777215, 3067734 } }, ;
	{ { 0.50, 3145727, 16777215 }, ;
	{ 0.50, 16777215, 3145727 } } ) }
oBtn3:lTransparent := .t.   
oBtn3:cToolTip =  { "Select" + CRLF + "Project","SELECT", 1, CLR_BLACK, 14089979 }
oBtn3:SetColor( 0, )

@ 165, 285 BTNBMP oBtn4 OF oDlg3 ;
SIZE 55, 22 PIXEL 2007 ;
ROUND NOBORDER ;
PROMPT " &Exit    " ;
FILENAME c_path1 + "Exit.Bmp" ;
ACTION oDlg3:End() ;
FONT oFont1 ;
LEFT
oBtn4:bClrGrad = { | lMouseOver | If( ! lMouseOver,;
	{ { 0.50, 6711039, 16777215 }, ;
	{ 0.50, 16777215, 6711039 } }, ;
	{ { 0.50, 16761992, 16777215 }, ;
	{ 0.50, 16777215, 16761992 } } ) }
oBtn4:lTransparent := .t.   
oBtn4:cToolTip =  { "Exit" + CRLF + "Project-edit","EXIT", 1, CLR_BLACK, 14089979 }
oBtn4:SetColor( 0, )

ACTIVATE DIALOG oDlg3 CENTERED ;
ON INIT  WD_BACKGRD( oDlg3, 3, , , , , "Brick.bmp" )

RETURN NIL

//------------- Title-Circle -----------

FUNCTION T_CIRCLE( oTitle, hDC, nColor1, nColor2, nCircleT, nCircleL, nPos ) 
LOCAL aRect := GETCLIENTRECT( oTitle:hWnd )
LOCAL oTBrush := TBrush():New(), nCTop := 0, nCLeft := 0, oText1

SYSWAIT(0.001)

IF nCircleT > 0		
		nCTop := ( aRect[3] / 100 ) * nCircleT
ENDIF
IF nCircleT < 0		
		nCTop := -1 + ( aRect[3] / 100 ) * ( nCircleT * 1 )
ENDIF
IF nCircleL > 0		
		nCLeft := ( aRect[4] / 100 ) * nCircleL
ENDIF
IF nCircleL < 0		
		nCLeft := -1 + ( aRect[4] / 100 ) * ( nCircleL * 1 ) 
ENDIF

DeleteObject( oTBrush:hBrush )
// hDC, { nTop, nLeft, nBottom, nRight }, startColor, endColor, nOffserY, nOffserX, lBrush --> hBitmap / hBrush
oTBrush:hBrush = CircleGradient( 0, aRect , nColor1, nColor2, nCLeft, nCTop, 1 )
oTitle:aGrdBack	:= {}	
FillRect( hDC, aRect, oTBrush:hBrush )
oTBrush:End()

RETURN( NIL )

//------------- Title-Diagonal -----------

FUNCTION T_DIAGONAL( oTitle, hDC, nColor1, nColor2, nDiagPos, lDirect, nPos ) 
LOCAL aRect := GETCLIENTRECT( oTitle:hWnd )
LOCAL oTBrush := TBrush():New()

SYSWAIT(0.001)

DeleteObject( oTBrush:hBrush )
// hDC, { nTop, nLeft, nBottom, nRight }, startColor, endColor, nOffserY, nOffserX, lBrush --> hBitmap / hBrush
oTBrush:hBrush = DGRADFILL( hDC, 0, 0, oTitle:nHeight, oTitle:nWidth, ;
                                 { { 0, nColor1, nColor1 }, { 0, nColor1, nColor1 }, ;
                                   { nDiagPos, nColor1, nColor2 }, ;
                                   { nDiagPos, nColor2, nColor1 }, ;
                                   { 1, nColor1, nColor1 }, { 1, nColor1, nColor1 } }, lDirect ) 		   
oTitle:aGrdBack	:= {}	
FillRect( hDC, aRect, oTBrush:hBrush )
oTBrush:End()

RETURN( NIL )

//------------- BMP-Brush -----------

FUNCTION DRAW_BMP( oBitmap, hDC, nStyle, nVColor, nBColor, lDDirect, nMove, cImage ) 
LOCAL aGrad := { { nMove, nVColor, nBColor }, { nMove, nBColor, nVColor } }
LOCAL aRect := GETCLIENTRECT( oBitmap:hWnd ), nCTop := 0, nCLeft := 0, nCircleT := 0, nCircleL := 0

IF nStyle = 1 // 1. Color
		DEFINE BRUSH oNewbrush COLOR nVColor
		FillRect( oBitmap:hDC, aRect, oNewbrush:hBrush )
		oNewbrush:End()
ENDIF
IF nStyle = 2 // Gradient
        DEFINE BRUSH oNewBrush ;
		COLOR GradientFill( hDC,  0, 0, aRect[3], aRect[4], aGrad, lDDirect ) // .T: = Vertical
		oNewbrush:End()
ENDIF
IF nStyle = 3 // Image
		IF FILE( c_path1 + cImage )
				DEFINE IMAGE oImage FILENAME c_path1 + cImage 
				nImgWidth := oImage:nWidth 
				nImgHeight := oImage:nHeight 
				nWFactor := aRect[4] / nImgWidth  
				nHFactor := aRect[3] / nImgHeight
	
				oImg0 := FILoadImg( c_path1 + cImage )
				lAlpha := HasAlpha( oImg0 )	

				//cSize := ALLTRIM(STR(oImg:nWidth)) + "x" + ALLTRIM(STR(oImg:nHeight)) + ;
				//		"   Resize-Factor : W = " + ALLTRIM(STR(nFactor1)) + " <> H = " + ALLTRIM(STR(nFactor2))		 
		 
				IF nWFactor > 1 .and. nHFactor > 1 
						nWidth := nImgWidth
						nHeight := nImgHeight
				ENDIF
				IF nWFactor < 1 .and. nHFactor < 1
						IF nWFactor < nHFactor			// Width-factor > Height-factor  
								nWidth := aRect[4]
								nHeight := nImgHeight * nWFactor 
						ELSE							// Width-factor < Height-factor  
								nWidth := nImgWidth * nHFactor
								nHeight := aRect[3]  
						ENDIF
				ENDIF
				IF nWFactor < 1 .and. nHFactor > 1	// 1800x500
						nWidth := aRect[4]
						nHeight := nImgHeight * nWFactor  
				ENDIF
				IF nWFactor > 1 .and. nHFactor < 1	// 600x1000
						nWidth := nImgWidth * nHFactor
						nHeight := aRect[3]
				ENDIF 

				IF lAlpha = .T.
						oImg := ResizeImg( oImg0, nWidth, nHeight )
						ABPaint( hDC, 0, 0, oImg0, 255 )
				ELSE
						PalBmpDraw( hDC, 0, 0, oImage:hBitmap, , nWidth, nHeight )
				ENDIF
				DeleteObject( oImg0 )
				DeleteObject( oImage )
		ELSE
				MsgAlert( "File : " + cImage + CRLF + ;
							"does not exist" + CRLF + ; 
							"to show Image !", "ATTENTION" ) 
		ENDIF
ENDIF

RETURN( NIL )

//------------- BMP-Circle -----------

FUNCTION CIRCLE_BMP( oBitmap, hDC, nVColor, nBColor ) 
LOCAL aRect := GETCLIENTRECT( oBitmap:hWnd )
LOCAL oNewbrush := TBrush():New()

DeleteObject( oNewbrush:hBrush )
// hDC, { nTop, nLeft, nBottom, nRight }, startColor, endColor, nOffserX, nOffserY, lBrush --> hBitmap / hBrush
oNewbrush:hBrush := CircleGradient( oBitmap:hDC, { aRect[1], aRect[2], aRect[3] -3, aRect[4] -3 }, nVColor, nBColor, 0, 0, 1 ) 
FillRect( oBitmap:hDC, aRect, oNewbrush:hBrush )
oNewbrush:End()

RETURN( NIL )

// --------------------------

STATIC FUNCTION CLEAR_SEL( oData )
LOCAL nOldPos := ("SET")->(ORDKEYNO())

DBGOTOP()
DO WHILE !EOF()
		NET_RLOCK( 3, 3 )
        IF ("SET")->(ORDKEYNO()) <> nOldPos
				("SET")->LSELECTED = .F.
		ELSE
				("SET")->LSELECTED := .T. 
		ENDIF
		NET_ULOCK()
		DBSKIP(+1)
ENDDO
DBGOTOP()
oData:Refresh()

RETURN( NIL )

// --------  DIALOG - Background ---------------

FUNCTION WD_BACKGRD( oWnd, nDStyle, nDColorF, nDColorB, nDGradpos, lDDirect, cDBrush )
Local hDC, oBrush, aGrad

IF nDStyle = 1
		DEFINE BRUSH oBrush COLOR nDColorF
ENDIF
IF nDStyle = 2
		aGrad := { { nDGradpos, nDColorF, nDColorB }, { nDGradpos, nDColorB, nDColorF } }
		hDC = CREATECOMPATIBLEDC( oWnd:GetDC() )
		hBmp = CREATECOMPATIBLEBITMAP( oWnd:hDC, oWnd:nWidth, oWnd:nHeight )
		hBmpOld = SELECTOBJECT( hDC, hBmp )
		GRADIENTFILL( hDC, 0, 0, oWnd:nHeight, oWnd:nWidth, aGrad, lDDirect ) // .T: = Vertical
		oBrush = TBrush():New( ,,,, hBmp )
		oWnd:SetBrush( oBrush )
		AEVAL( oWnd:aControls, { | oCtl | IF( oCtl:lTransparent, oCtl:SetBrush( oWnd:oBrush ), ) } )
		SELECTOBJECT( hDC, hBmpOld )
		DELETEDC( hDC )
		oWnd:ReleaseDC()
		RELEASE BRUSH oBrush 
ENDIF
IF nDStyle = 3
		IF FILE( c_path1 + cDBrush ) 
				DEFINE BRUSH oBrush FILE c_path1 + cDBrush
		ELSE
				MsgAlert( "File : " + cDBrush + CRLF + ;
									"does not exist" + CRLF + ; 
									"to create brush !", "ATTENTION" ) 
				RETURN( NIL )
		ENDIF
ENDIF
IF nDStyle <> 2
		oWnd:SetBrush( oBrush )
		RELEASE BRUSH oBrush 
ENDIF

RETURN( NIL )

// ----------------

STATIC FUNCTION GO_START()

IF FILE( c_Path + "PROJECT.DBF" ) 
		NET_USE ( c_Path + "PROJECT.DBF", "SET", 3,.T. ) 
		DBSELECTAREA("SET")
        ORDCREATE( ,"PROJECT","UPPER(CPROJECT)", ;
	                                {|| UPPER(CPROJECT) } , .F. )
		DBGOTOP()
		DO WHILE !EOF()
				IF ("SET")->LSELECTED = .T.
						EXIT
				ENDIF
				DBSKIP(+1)
		ENDDO
		cBrwPos := ALLTRIM(("SET")->CPROJECT)
ELSE
		MsgAlert( "PROJECT.DBF doesn't exist", "Attention")
		QUIT
ENDIF

RETURN NIL

// ----------------

FUNCTION LOAD_DBF(oDlg, lSkip)

IF lSkip = .T.
		IF ("SET")->(EOF())
				DBGOTOP()
		ENDIF
		IF ("SET")->(BOF())
				DBGOBOTTOM()
		ENDIF
ENDIF

cProject				:=	 TRIM(("SET")->CPROJECT)
oDlg:cTitle := "Folder RGB-colors   => " + cProject	
lSelected           := ("SET")->LSELECTED

nResRGB			:= ("SET")->NRESRGB
nBrightGrd		:= ("SET")->NBRIGHTGRD
nResBright		:= ("SET")->NRESBRIGHT
nDarkGrd			:= ("SET")->NDARKGRD
nResDark			:= ("SET")->NRESDARK

nValRGB			:= ("SET")->NVALRGB
cTextRGB			:= ("SET")->CTEXTRGB
cWordRGB		:= ("SET")->CWORDRGB
nBrightRGB		:= ("SET")->NBRIGHTRGB

nGradCol1		:= ("SET")->NGRADCOL1
cGradCol1		:= ("SET")->CGRADCOL1
nGradCol2		:= ("SET")->NGRADCOL2
cGradCol2		:= ("SET")->CGRADCOL2
lGrdDirect			:= ("SET")->LGRDDIRECT
lDDirect				:= ("SET")->LDDIRECT
nGradPos			:= ("SET")->NGRADPOS
nDiagPos			:= ("SET")->NDIAGPOS
nCircleT			:= ("SET")->NCIRCLET		
nCircleL			:= ("SET")->NCIRCLEL

n1_GradC1		:= ("SET")->N1_GRADC1
n1_GradC2		:= ("SET")->N1_GRADC2
l1_GradDir		:= ("SET")->L1_GRADDIR
l1_DiagDir			:= ("SET")->L1_DIAGDIR
n1_Gradpos		:= ("SET")->N1_GRADPOS
n1_DiagPos		:= ("SET")->N1_DIAGPOS
n1_CircleT		:= ("SET")->N1_CIRCLET		
n1_CircleL		:= ("SET")->N1_CIRCLEL
n1_Grad			:= ("SET")->N1_GRAD 

n2_GradC1		:= ("SET")->N2_GRADC1
n2_GradC2		:= ("SET")->N2_GRADC2
l2_GradDir		:= ("SET")->L2_GRADDIR
l2_DiagDir			:= ("SET")->L2_DIAGDIR
n2_Gradpos		:= ("SET")->N2_GRADPOS
n2_DiagPos		:= ("SET")->N2_DIAGPOS
n2_CircleT		:= ("SET")->N2_CIRCLET		
n2_CircleL		:= ("SET")->N2_CIRCLEL
n2_Grad			:= ("SET")->N2_GRAD 

n3_GradC1		:= ("SET")->N3_GRADC1
n3_GradC2		:= ("SET")->N3_GRADC2
l3_GradDir		:= ("SET")->L3_GRADDIR
l3_DiagDir			:= ("SET")->L3_DIAGDIR
n3_Gradpos		:= ("SET")->N3_GRADPOS
n3_DiagPos		:= ("SET")->N3_DIAGPOS
n3_CircleT		:= ("SET")->N3_CIRCLET		
n3_CircleL		:= ("SET")->N3_CIRCLEL
n3_Grad			:= ("SET")->N3_GRAD 

n4_GradC1		:= ("SET")->N4_GRADC1
n4_GradC2		:= ("SET")->N4_GRADC2
l4_GradDir		:= ("SET")->L4_GRADDIR
l4_DiagDir			:= ("SET")->L4_DIAGDIR
n4_Gradpos		:= ("SET")->N4_GRADPOS
n4_DiagPos		:= ("SET")->N4_DIAGPOS
n4_CircleT		:= ("SET")->N4_CIRCLET		
n4_CircleL		:= ("SET")->N4_CIRCLEL
n4_Grad			:= ("SET")->N4_GRAD 

n5_GradC1		:= ("SET")->N5_GRADC1
n5_GradC2		:= ("SET")->N5_GRADC2
l5_GradDir		:= ("SET")->L5_GRADDIR
l5_DiagDir			:= ("SET")->L5_DIAGDIR
n5_Gradpos		:= ("SET")->N5_GRADPOS
n5_DiagPos		:= ("SET")->N5_DIAGPOS
n5_CircleT		:= ("SET")->N5_CIRCLET		
n5_CircleL		:= ("SET")->N5_CIRCLEL
n5_Grad			:= ("SET")->N5_GRAD 

RETURN NIL

// ---------- NET - FUNCTIONS ----------------------------

FUNCTION NET_USE ( cDBName, cAlias, nTrials, lNet )
LOCAL lReturn  := .T.
LOCAL lOpen    := .F.

nTrcount   := nTrials
YesNo := .F.

// SHARED    all Users
// EXCLUSIVE  1 User

IF File( cDBName )
		nTrials := nTrcount
		DO WHILE !lOpen
				DO WHILE .T.
						IF !lNet
								USE &cDBName ALIAS &cAlias NEW EXCLUSIVE
						ELSE
								USE &cDBName ALIAS &cAlias NEW SHARED
						ENDIF
						IF !NetErr()
								lReturn   := .T.
								lOpen     := .T.
								nTrials := 0
						ELSE
								IF lNet = .T.
										Status := "SHARED"
								ELSE
										Status := "EXCLUSIVE"
								ENDIF
								IF nTrcount = nTrials
										xName := WNetGetUser()
										IF MsgYesNo( "Open " + Status + "  of " + upper(cDBName) + " not possible !" + ;
																" try again ?", "Network-error -> &xName !" )
												nTrials := nTrcount
												YesNo := .T.
										ELSE
												nTrials := 0
												YesNo := .F.
										ENDIF
								ENDIF
								IF YesNo = .T.
										nTrials --
										IF nTrials > 0 .AND. nTime > 0
												NET_WAIT ( nTrcount, nTrials, nTime)
										ENDIF
										IF nTrials = 0
												nTrials := nTrcount
										ENDIF
								ELSE
										lReturn   := .F.
										lOpen     := .T.
										nTrials := 0
								ENDIF
						ENDIF
						IF nTrials = 0
								lOpen := .T.
								EXIT
						ENDIF
				ENDDO
		ENDDO
ELSE
		nMsgBox ("File -> " + cDBName + " is missing !", "Attention !")
		SET RESOURCES to
		set _3DLOOK OFF
		FreeLibrary()
		Close database
		QUIT
ENDIF

RETURN lReturn

// ----------------------

FUNCTION NET_WAIT ( nTrcount, nTrials, nTime )

local oMeter, oText1

MsgMeter( { | oMeter, oText1 | ;
SHOW_WAIT(nTrcount, nTrials, nTime, oMeter, oText1) } , ;
"rest trials : " + LTRIM(STR(nTrials)) + ". trial..." )

RETURN nil

// ----------------------

STATIC FUNCTION SHOW_WAIT( nTrcount, nTrials, nTime, oMeter, oText1 )

oMeter:nTotal = nTrcount
nZSek := Seconds()
oText1:SetText( "rest of trials : " + ltrim(str(nTrials)))
oMeter:Set( nTrials )
SysRefresh()
DO WHILE Seconds() < nZSek + nTime
ENDDO

RETURN nil

//-------------------------------------------------------

FUNCTION NET_RLOCK( nTrials, nTime )
LOCAL   lReturn   := .F.
LOCAL   nTrcount   := 0
LOCAL   nZSek     := 0
nTrcount := nTrials

DO WHILE !lReturn
		DO WHILE nTrials > 0
				IF !RLock()
						nTrials --
						IF nTrials > 0 .AND. nTime > 0
								NET_WAIT ( nTrcount, nTrials, nTime )
						ENDIF
				ELSE
						lReturn := .T.
						EXIT
				ENDIF
		ENDDO
		IF nTrials = 0
				IF MsgYesNo( "Not possible, to lock the record !" + ;
									" Try again ?", "Network Error !" )
						nTrials := nTrcount
				ELSE
						lReturn := .F.
						EXIT
				ENDIF
		ENDIF
ENDDO
IF lReturn = .F.
		nMsgBox ("Files are not saved !!!", "Attention !")
ENDIF

RETURN lReturn

//-------------------------------------------------------

FUNCTION NET_ULOCK()

LOCAL   lReturn   := .F.

IF len(Fieldname(1)) > 0                     
		UNLOCK                                      
ENDIF

RETURN lReturn

// ----------------------

FUNCTION NET_CLOSE( nTrials, nTime )

LOCAL lReturn  := .T.
LOCAL lOpen    := .F.

nTtrcount   := nTrials
YesNo    := .F.

cDBName := DBF()

DO WHILE !lOpen
		DO WHILE nTrials > 0
				USE
				IF NetErr()
						nTrials --
						IF MsgYesNo( "Close of file : " + upper(cDBName) + " not possible !" + ;
												" Try again ?", "Network-Error !" )
								lOpen :=.T.
								nTrials := ntrcount
								IF nTrials > 0 .AND. nTime > 0
										NET_WAIT ( nTrcount, nTrials, nTime)
								ENDIF
						ELSE
								lReturn   := .F.
								lOpen     := .T.
								nTrials := 0
						ENDIF
				ELSE
						lReturn   := .T.
						lOpen     := .T.
						nTrials := 0
				ENDIF
		ENDDO
ENDDO

RETURN lReturn

// -----------------

FUNCTION DGRADFILL( hDC, nTop, nLeft, nBottom, nRight, aGradInfo, lDirection )
LOCAL nClr := 1, nClrs := Len( aGradInfo )
LOCAL nSize, nStart, nEnd

default lDirection := .T.

IF Empty( aGradInfo )
		RETURN NIL
ENDIF

nSize    = ( nBottom - nTop ) + ( nRight - nLeft )
nStart   = 0
nEnd     = 0

FOR nClr := 1 to nClrs
		nStart = nEnd  
		nEnd   += ( nSize * ( aGradInfo[ nClr ][ 1 ] ) )

		DiagonalGradient( hDC, ;
                       { nTop, nLeft, nBottom, nRight },;
                        aGradInfo[ nClr ][ 2 ], ;
                        aGradInfo[ nClr ][ 3 ], ;
                        lDirection, ;
                        nStart, ;
                        nEnd )
NEXT

RETURN NIL

// ---------------------------

#pragma BEGINDUMP

#include <hbapi.h>
#include <windows.h>
#include <math.h>

#define PI 3.14159265
#define BRUSH  1
#define BITMAP 2

#ifdef __XHARBOUR__
   int hb_parvni( int iParam, int iIndex );
#endif


HGDIOBJ CircleGradient( HDC hDC,  RECT * rect, COLORREF startColor, COLORREF endColor, INT iOffSetX, INT iOffSetY, int iOutPut );

HGDIOBJ CircleGradient( HDC hDC, RECT * rect, COLORREF startColor, COLORREF endColor, INT iOffSetX, INT iOffSetY, int iOutPut )
{	int i, j;
	float fRadio;
	HBITMAP hBitmap;
	HBITMAP hOldBitmap;
	HBRUSH hBrush;
	HDC hMemDC;
 
	// Calculate image size
	int width; 
	int height;
	int isize;
	double radius, diameterx, diametery;
	char *m_Data;
	int icenterx, icentery;

	diameterx = ( rect->right - rect->left);
	diametery = ( rect->bottom - rect->top);
	icentery  = diametery * 0.5 ;
	icenterx  = diameterx * 0.5 ;

	width  = rect->right - rect->left;
	height = rect->bottom - rect->top;
	radius = sqrt( pow( icenterx, 2 ) + pow( icentery, 2 ) ) ; 
	isize  = height * width * 4;

	// Create data buffer
	m_Data = hb_xgrab( isize );
	
	// Create gradient
	for ( i = 0; i < height; i++ )
		{
			for ( j = 0; j < width; j++ )
				{
					LONG lRed, lBlue, lGreen;		   
					fRadio = sqrt( pow( ( j - icenterx - iOffSetX ), 2 ) + ( pow( ( i - icentery - iOffSetY ), 2 ) ) ) / radius * 100.0;
					if ( fRadio > 0.0 )
						{
							if( fRadio > 100.0 )
								{
									lRed   = GetBValue( endColor );
									lGreen = GetGValue( endColor ); 
									lBlue  = GetRValue( endColor );
								}else
								{
									lRed   = GetBValue( startColor ) + ( fRadio * 0.01 * ( GetBValue( endColor ) - GetBValue( startColor ) ) );
									lGreen = GetGValue( startColor ) + ( fRadio * 0.01 * ( GetGValue( endColor ) - GetGValue( startColor ) ) ); 
									lBlue  = GetRValue( startColor ) + ( fRadio * 0.01 * ( GetRValue( endColor ) - GetRValue( startColor ) ) );
								}

						}
					else
						{
							lRed   = GetBValue( startColor );
							lGreen = GetGValue( startColor );
							lBlue  = GetRValue( startColor );
						}
							m_Data[ i * width * 4 + j * 4    ] = lRed;
							m_Data[ i * width * 4 + j * 4 + 1] = lGreen;
							m_Data[ i * width * 4 + j * 4 + 2] = lBlue;
				}
			}

			hBitmap = CreateBitmap( width, height, 1, 32, m_Data );

			// Free memory

			SelectObject( hMemDC, hOldBitmap );
			DeleteDC(hMemDC);

			hb_xfree( m_Data );

			if( iOutPut == BRUSH )
				{
					hBrush = CreatePatternBrush( hBitmap );
					DeleteObject( hBitmap );
					return hBrush;
				}
			else if( iOutPut == BITMAP ) return hBitmap;
			else if( hDC != 0 )
				{
					hBrush = CreatePatternBrush( hBitmap );
					FillRect( hDC, rect, hBrush );
					DeleteObject( hBrush );
				}  

			DeleteObject( hBitmap );
			return 0;
}

// ----------

HB_FUNC( CIRCLEGRADIENT ) // hDC, { nTop, nLeft, nBottom, nRight },
                          // startColor, endColor, nOffserX, 
                          // nOffserY, lBrush --> hBitmap / hBrush ( GDI OBJECT )
{
	RECT rct; 
	INT iOffX = 0, iOffY = 0;
	INT iOutPut = 3;

	rct.top    = hb_parvni( 2, 1 ); 
	rct.left   = hb_parvni( 2, 2 ); 
	rct.bottom = hb_parvni( 2, 3 ); 
	rct.right  = hb_parvni( 2, 4 ); 

	if( hb_pcount() > 4 )
		iOffX = hb_parni( 5 );
   
	if( hb_pcount() > 5 )
		iOffY = hb_parni( 6 );

	if( hb_pcount() > 6 )
		iOutPut = hb_parni( 7 );

	hb_retnl( ( LONG ) CircleGradient( ( HDC ) hb_parnl( 1 ),
	                                   &rct,
	                                   ( COLORREF ) hb_parnl( 3 ),
	                                   ( COLORREF ) hb_parnl( 4 ),
	                                   iOffX, 
	                                   iOffY, 
	                                   iOutPut ) );
}

#pragma ENDDUMP